import { ElementInternals } from 'element-internals-polyfill/dist/element-internals';
import { Constructor, CustomElement, CustomElementClass } from 'web-utility';
import { IReactionDisposer } from 'mobx';
import { WebCellProps } from './utility';
import { ComponentMeta, DOMEventDelegater } from './decorator';
export interface WebCellComponent<P extends WebCellProps = WebCellProps> extends CustomElement {
    internals?: ElementInternals;
    root?: DocumentFragment | HTMLElement;
    update?(): void;
    /**
     * @deprecated Get values from `this` directly since WebCell 3.0.0
     */
    props?: P;
    disposers?: IReactionDisposer[];
    syncPropAttr?(name: string): void;
    defaultSlot?: JSX.Element;
    render?(): JSX.Element | undefined;
    /**
     * Called after rendering
     */
    updatedCallback?(): void;
    emit?(event: string, detail?: any, options?: EventInit): boolean;
    toString(): string;
}
export interface WebCellClass<P extends WebCellProps = WebCellProps> extends Pick<CustomElementClass, 'observedAttributes'>, Partial<ComponentMeta>, Constructor<WebCellComponent<P>> {
    eventDelegaters?: DOMEventDelegater[];
}
export declare function WebCell<P extends WebCellProps = WebCellProps>(superClass?: Constructor<CustomElement>): WebCellClass<P>;
export declare type ComponentClass = {
    new (): InstanceType<ReturnType<typeof WebCell>>;
};
