import { DelegateEventHandler } from 'web-utility';
import { FunctionComponent } from './utility/vDOM';
import { WebCellClass, ComponentClass } from './WebCell';
export interface ComponentMeta extends Partial<ShadowRootInit> {
    tagName: `${string}-${string}`;
    extends?: keyof HTMLElementTagNameMap;
}
export declare function component(meta: ComponentMeta): <T extends WebCellClass<import("./utility/vDOM").WebCellProps<HTMLElement>>>(Class: T) => T;
export declare function observer<T extends FunctionComponent | ComponentClass>(Component: T): any;
export declare function attribute<T extends InstanceType<WebCellClass>>({ constructor }: T, key: string): void;
export interface DOMEventDelegater {
    type: keyof HTMLElementEventMap;
    selector: string;
    method: string;
}
export declare function on(type: DOMEventDelegater['type'], selector: string): <T extends DelegateEventHandler<any>, I extends import("./WebCell").WebCellComponent<import("./utility/vDOM").WebCellProps<HTMLElement>>>({ constructor }: I, method: string, meta: PropertyDescriptor) => PropertyDescriptor & {
    value: T;
};
